<?php

/**
 * 发送http请求
 * @access protected
 * @param string $url  请求地址
 * @param string $param  get方式请求内容，数组形式，post方式时无效
 * * @param string $data  post请求方式时的内容，get方式时无效
 * @param string $method  请求方式，默认get
 */
function http($url, $param, $data = '', $method = 'GET'){
	$opts = array(
		CURLOPT_TIMEOUT        => 30,
		CURLOPT_RETURNTRANSFER => 1,
		CURLOPT_SSL_VERIFYPEER => false,
		CURLOPT_SSL_VERIFYHOST => false,
	);

	/* 根据请求类型设置特定参数 */
	$opts[CURLOPT_URL] = $url . '?' . http_build_query($param);

	if(strtoupper($method) == 'POST'){
		$opts[CURLOPT_POST] = 1;
		$opts[CURLOPT_POSTFIELDS] = $data;

		if(is_string($data)){ //发送JSON数据
			$opts[CURLOPT_HTTPHEADER] = array(
				'Content-Type: application/json; charset=utf-8',
				'Content-Length: ' . strlen($data),
			);
		}
	}

	/* 初始化并执行curl请求 */
	$ch = curl_init();
	curl_setopt_array($ch, $opts);
	$data  = curl_exec($ch);
	$error = curl_error($ch);
	curl_close($ch);

	//发生错误，抛出异常
	if($error) throw new \Exception('请求发生错误：' . $error);

	return  $data;
}

function msend_sms($sms_user, $sms_pwd, $mobile, $content)
{
	
	$target = 'http://api.smsbao.com/sms';
	$post_data['u']=$sms_user;
	$post_data['p']=md5($sms_pwd);
	$post_data['m']=$mobile;
	$post_data['c']=$content;
	echo $content;
	return $gets = http($target, $post_data);
}

function msend_regsms($sms_user, $sms_pwd, $mobile, $yzm, $sms_regtpl = '')
{
	$content = str_replace('{code}', $yzm, $sms_regtpl);
	$content = str_replace('{mobile}', $mobile, $content);
	$content = ($content ? $content : '您的验证码是：' . $yzm . '。请不要把验证码泄露给其他人。如非本人操作，可不用理会！');
	$status = msend_sms($sms_user, $sms_pwd, $mobile, $content);
	write_sms_sendrecord($mobile, $content, $status, 'smsbao');
}

function msend_pwdsms($sms_user, $sms_pwd, $mobile, $yzm, $sms_pwdtpl = '')
{
	$content = str_replace('{code}', $yzm, $sms_pwdtpl);
	$content = str_replace('{mobile}', $mobile, $content);
	$content = ($content ? $content : '您的手机号：' . $mobile . '，找回密码验证码：' . $yzm . '，请不要把验证码泄露给其他人。如非本人操作，可不用理会！');
	$status = msend_sms($sms_user, $sms_pwd, $mobile, $content);
	write_sms_sendrecord($mobile, $content, $status, 'smsbao');
}


?>
